#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QPlainTextEdit>

#include <QtMidi/QMidiDeviceInfo>
#include <QtMidi/QMidiInput>

class MainWindow
        : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected slots:
    void addLine(QString line);
    void printInputDevices();
    void printOutputDevices();

    void inputDeviceAttached(const QMidiDeviceInfo info);
    void outputDeviceAttached(const QMidiDeviceInfo info);
    void inputDeviceDetached(const QMidiDeviceInfo info);
    void outputDeviceDetached(const QMidiDeviceInfo info);

    void inputDeviceCreated(const QMidiInput* device);

    void receiveMessage(const QMidiMessage &m);
    /*
protected:
    virtual void inputDeviceAttached(umidi::MidiDeviceID id) override final;
    virtual void outputDeviceAttached(umidi::MidiDeviceID id) override final;

    virtual void inputDeviceDetached(umidi::MidiDeviceID id) override final;
    virtual void outputDeviceDetached(umidi::MidiDeviceID id) override final;

    virtual void inputDeviceCreated(umidi::MidiInputDevicePtr device) override final;
    virtual void outputDeviceCreated(umidi::MidiOutputDevicePtr device) override final;

    virtual void inputDeviceDeleted(umidi::MidiDeviceID id) override final;
    virtual void outputDeviceDeleted(umidi::MidiDeviceID id) override final;

    */
private:
    QPlainTextEdit* mConsoleOutput;
};

#endif // MAINWINDOW_H
